import bindings = require('bindings');

bindings('binding.node');
bindings({
    arrow: process.env.NODE_BINDINGS_ARROW || ' → ',
    compiled: process.env.NODE_BINDINGS_COMPILED_DIR || 'compiled',
    platform: process.platform,
    arch: process.arch,
    nodePreGyp: `node-v${process.versions.modules}-${process.platform}-${process.arch}`,
    version: process.versions.node,
    bindings: 'bindings.node',
    try: [
        // node-gyp's linked version in the "build" dir
        ['module_root', 'build', 'bindings'],
        // node-waf and gyp_addon (a.k.a node-gyp)
        ['module_root', 'build', 'Debug', 'bindings'],
        ['module_root', 'build', 'Release', 'bindings'],
        // Debug files, for development (legacy behavior, remove for node v0.9)
        ['module_root', 'out', 'Debug', 'bindings'],
        ['module_root', 'Debug', 'bindings'],
        // Release files, but manually compiled (legacy behavior, remove for node v0.9)
        ['module_root', 'out', 'Release', 'bindings'],
        ['module_root', 'Release', 'bindings'],
        // Legacy from node-waf, node <= 0.4.x
        ['module_root', 'build', 'default', 'bindings'],
        // Production "Release" buildtype binary (meh...)
        ['module_root', 'compiled', 'version', 'platform', 'arch', 'bindings'],
        // node-qbs builds
        ['module_root', 'addon-build', 'release', 'install-root', 'bindings'],
        ['module_root', 'addon-build', 'debug', 'install-root', 'bindings'],
        ['module_root', 'addon-build', 'default', 'install-root', 'bindings'],
        // node-pre-gyp path ./lib/binding/{node_abi}-{platform}-{arch}
        ['module_root', 'lib', 'binding', 'nodePreGyp', 'bindings'],
    ],
});

bindings.getFileName(); // $ExpectType string
bindings.getFileName('/node_modules/foo/index.js'); // $ExpectType string
bindings.getRoot(process.cwd()); // $ExpectType string
